# Use this command to obfuscate the shit out of this file
# pyminifier --replacement-length=5 --obfuscate-variables --obfuscate-import-methods --gzip -o channelQualityCorrection.py secretCorrection.py

import numpy as np
import matplotlib.pyplot as plt


# def channel_quality_correction(iq, inst, vsaIPAddress='127.0.0.1', vsaHardware='"Analyzer1"',
#                             cf=1e9, numTones=1001, toneSpacing=40e3):
#     """
#     IQ correction using the channel quality measurement in VSA.
#     Args:
#         iq (NumPy array): Array of iq values to be corrected.
#         inst (pyarbtools.instruments class): Instrument object to be used for signal generation.
#         vsaIPAddress (string): IP Address for the instance of VSA that will be used for calibration.
#         vsaHardware (string): Hardware to be used by VSA for calibration. Name must be contained in double-quotes.
#         cf (float): Center frequency at which calibration takes place in Hz.
#         span (float): Span of calibration in Hz.
#         toneSpacing (float): Space between tones in multitone stimulus used for calibration. Number of tones automatically calculated.
#
#     Returns:
#         iqCorr (NumPy array): Array of corrected iq values.
#     """
#
#     """
#     Zero phase should be used as a stimulus signal so that we have a known phase relationship against which to correct.
#     DONE LEAVING IT ALONE --------- Still needs work on treatment of carrier leakage. Or maybe just leave it alone?
#     DONE --------- Still needs work on actually correcting phase.
#     Still need to fix inaccurate tone measurement in VSA.
#     Still needs HEAVY documentation.
#     Still needs obfuscation.
#     Problem with large number of tones --------- Still needs extensive testing of number of tones, tone spacing, and sample rates.
#     There's STILL a problem with actually creating the multitone stimulus.
#     """
#
#     correctedIQ, magImprovement, phaseImprovement = channelQualityCorrection.channel_quality_correction(iq, inst, vsaIPAddress, vsaHardware, cf, numTones, toneSpacing)
#
#     return correctedIQ, magImprovement, phaseImprovement


def channel_quality_correction(iq, inst, vsaIPAddress='127.0.0.1', vsaHardware='"Analyzer1"',
                            cf=1e9, numTones=1001, toneSpacing=40e3, plot=False):
    """
    IQ correction using the channel quality measurement in VSA.
    Args:
        iq (NumPy array): Array of iq values to be corrected.
        inst (pyarbtools.instruments class): Instrument object to be used for signal generation.
        vsaIPAddress (string): IP Address for the instance of VSA that will be used for calibration.
        vsaHardware (string): Hardware to be used by VSA for calibration. Name must be contained in double-quotes.
        cf (float): Center frequency at which calibration takes place in Hz.
        span (float): Span of calibration in Hz.
        toneSpacing (float): Space between tones in multitone stimulus used for calibration. Number of tones automatically calculated.

    Returns:
        iqCorr (NumPy array): Array of corrected iq values.
    """

    """
    Zero phase should be used as a stimulus signal so that we have a known phase relationship against which to correct.
    DONE LEAVING IT ALONE --------- Still needs work on treatment of carrier leakage. Or maybe just leave it alone?
    DONE --------- Still needs work on actually correcting phase.
    Still need to fix inaccurate tone measurement in VSA.
    Still needs HEAVY documentation.
    Still needs obfuscation.
    Problem with large number of tones --------- Still needs extensive testing of number of tones, tone spacing, and sample rates.
    There's STILL a problem with actually creating the multitone stimulus.
    """

    name = 'corr'
    iqCorr = multitone(fs=inst.fs, spacing=toneSpacing, num=numTones, phase='zero',
                       cf=cf, wfmFormat='iq')

    inst.download_wfm(iqCorr, name)
    inst.play(name)

    vsa = communications.SocketInstrument(vsaIPAddress, 5025, timeout=30)

    hwList = vsa.query('system:vsa:hardware:configuration:catalog?').split(',')
    if vsaHardware not in hwList:
        raise ValueError('Selected hardware not present in VSA hardware list.')
    vsa.write(f'system:vsa:hardware:configuration:select {vsaHardware}')
    vsa.query('*opc?')

    # Configure basic settings
    print('Setting up VSA...')
    # vsa.write('*rst')
    # vsa.query('*opc?')
    vsa.write('initiate:continuous 1')
    vsa.write('initiate:immediate')
    vsa.write('measure:nselect 1')
    vsa.write('measure:configure cquality')
    vsa.query('*opc?')
    vsa.write('sense:cquality:preset')

    vsa.write(f'sense:frequency:center {cf}')
    vsa.write(f'sense:frequency:span {(toneSpacing * numTones) * 1.1}')
    vsa.write(f'sense:cquality:mtone:configure {toneSpacing}, {numTones}')
    vsa.write('sense:cquality:mtone')
    vsa.write('sense:cquality:mtone:atone:threshold:auto 1')
    # vsa.write('sense:cquality:mtone:update 1')
    # vsa.write('sense:cquality:analysis:interval 1e-3')
    vsa.write('input:analog:range:auto')
    vsa.query('*opc?')

    # print(vsa.query('trace1:data:name:list?'))
    vsa.write('trace1:data:name "Ch Frequency Response1"')
    vsa.write('trace1:format "LinearMagnitude"')
    # vsa.write('trace1:format "Real"')
    vsa.write('trace2:data:name "Ch Frequency Response1"')
    vsa.write('trace2:format "UnwrapPhase"')
    # vsa.write('trace2:format "Imaginary"')
    # vsa.write('trace3:add')
    vsa.write('trace3:data:name "Spectrum1"')
    vsa.write('trace3:format "LogMagnitude"')
    # vsa.write('trace4:add')
    vsa.write('display:layout 3,1')
    vsa.write('initiate:continuous off')
    vsa.write('initiate:immediate')
    vsa.query('*opc?')
    vsa.write('trace1:autoscale')
    vsa.write('trace2:autoscale')
    vsa.query('*opc?')
    sleep(1)

    """Secret Time"""
    didItGo = False
    while didItGo == False:
        try:
            vsa.write('format:trace:data real64')
            vsa.write('trace1:data:y?')
            eqMagnitude = vsa.binblockread(dtype=np.float64).byteswap()
            # realCorr = vsa.binblockread(dtype=np.float64).byteswap()
            vsa.write('format:trace:data real64')
            vsa.write('trace2:data:y?')
            eqPhase = vsa.binblockread(dtype=np.float64).byteswap()
            didItGo = True
        except error.timeout:
            print('binblockread timed out, trying again.')
    # imagCorr = vsa.binblockread(dtype=np.float64).byteswap()

    if plot:
        # plt.plot(finalFreq, iqCorr.real)
        # plt.plot(finalFreq, iqCorr.imag)
        fig = plt.figure(1)
        sp1 = fig.add_subplot(211)
        sp1.set_title('Magnitude Response')
        sp1.plot(20 * np.log10(eqMagnitude))
        sp2 = fig.add_subplot(212)
        sp2.set_title('Phase Response')
        sp2.plot(eqPhase)

    """Pre-correction Signal Quality"""
    magMax = 20 * np.log10(np.amax(eqMagnitude))
    magMin = 20 * np.log10(np.amin(eqMagnitude))

    phaseMax = np.amax(eqPhase)
    phaseMin = np.amin(eqPhase)

    print('################Original################')
    print(f'Magnitude flatness: {magMax - magMin} dB pp')
    # print(f'Magnitude Average: {magAvg}')

    print(f'Phase flatness: {phaseMax - phaseMin} degrees pp')
    # print(f'Phase Average: {phaseAvg} degrees')


    # FFT Method
    # Convert original signal to frequency domain
    iqFreqDomain = np.fft.fftshift(np.fft.fft(iq)) / len(iq)
    finalFreq = np.fft.fftshift(np.fft.fftfreq(len(iqFreqDomain), 1 / inst.fs))

    # Create a new interpolated frequency array and interpolate magCorr and phaseCorr
    # originalFreq = np.linspace(-0.5, 0.5, len(realCorr))
    originalFreq = np.linspace(-numTones * toneSpacing / 2, numTones * toneSpacing / 2, numTones)
    # originalFreq = np.linspace(-inst.fs / 2, inst.fs / 2, numTones)
    # finalFreq = np.linspace(-numTones * toneSpacing / 2, numTones * toneSpacing / 2, len(iqFreqDomain))
    eqMagnitude = np.interp(finalFreq, originalFreq, eqMagnitude)
    eqPhase = np.interp(finalFreq, originalFreq, eqPhase)
    # realCorr = np.interp(finalFreq, originalFreq, realCorr)
    # imagCorr = np.interp(finalFreq, originalFreq, imagCorr)

    # iqCorr = 1 / magCorr * np.exp(1j * np.pi * phaseCorr / 180)
    iqCorr = 1 / eqMagnitude * np.exp(-1j * np.pi * eqPhase / 180)

    maxLoc = np.argmax(iqCorr)
    # Check for odd number of tones
    if np.mod(len(iqCorr), 2) != 0:
        # If odd, compensate for middle tone
        iqCorr[maxLoc] = np.mean([iqCorr[maxLoc - 1], iqCorr[maxLoc + 1]])
    # iqCorr = 1 / (realCorr - 1j * imagCorr)

    # Apply correction vector to original signal (multiplication in freq domain = convolution in time domain)
    correctedIQ = iqFreqDomain * iqCorr
    # Convert corrected signal back into time domain
    correctedIQ = np.fft.ifft(np.fft.fftshift(correctedIQ))

    # Normalize output waveform
    sFactor = abs(np.amax(correctedIQ))
    correctedIQ = correctedIQ / sFactor * 0.707

    # Post-correction testing

    inst.download_wfm(correctedIQ, wfmID='corrected')
    inst.play(wfmID='corrected')
    inst.query('*opc?')
    sleep(1)

    vsa.write('initiate:immediate')
    vsa.query('*opc?')

    vsa.write('format:trace:data real64')
    vsa.write('trace1:data:y?')
    corrEqMagnitude = vsa.binblockread(dtype=np.float64).byteswap()
    # realCorr = vsa.binblockread(dtype=np.float64).byteswap()
    vsa.write('format:trace:data real64')
    vsa.write('trace2:data:y?')
    corrEqPhase = vsa.binblockread(dtype=np.float64).byteswap()
    # imagCorr = vsa.binblockread(dtype=np.float64).byteswap()

    """Pre-correction Signal Quality"""
    corrMagMax = 20 * np.log10(np.amax(corrEqMagnitude))
    corrMagMin = 20 * np.log10(np.amin(corrEqMagnitude))

    corrPhaseMax = np.amax(corrEqPhase)
    corrPhaseMin = np.amin(corrEqPhase)

    print('################Corrected################')
    print(f'Magnitude flatness: {corrMagMax - corrMagMin} dB pp')
    # print(f'Magnitude Average: {corrMagAvg}')

    print(f'Phase flatness: {corrPhaseMax - corrPhaseMin} degrees pp')
    # print(f'Phase Average: {corrPhaseAvg} degrees')

    magImprovement = 100 * ((magMax - magMin) - (corrMagMax - corrMagMin)) / (magMax - magMin)
    phaseImprovement = 100 * ((phaseMax - phaseMin) - (corrPhaseMax - corrPhaseMin)) / (phaseMax - phaseMin)
    print(f'NumTones: {numTones}. ToneSpacing {toneSpacing / 1000} kHz')
    print(f'\nMagnitude improvement {magImprovement} %')
    print(f'Phase improvement {phaseImprovement} %\n')

    if plot:
        sp1.plot(20 * np.log10(corrEqMagnitude))
        sp2.plot(corrEqPhase)
        plt.tight_layout()
        plt.show()

    return correctedIQ, magImprovement, phaseImprovement
